Index: geniuswebcore/test/geniusweb/simplerunner/ClassPathConnectionFactoryTest.py
===================================================================
--- geniuswebcore/test/geniusweb/simplerunner/ClassPathConnectionFactoryTest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/simplerunner/ClassPathConnectionFactoryTest.py	(revision 67)
@@ -0,0 +1,63 @@
+import time
+import unittest
+
+from uri.uri import URI
+
+from geniusweb.references.PartyRef import PartyRef
+from geniusweb.simplerunner.ClassPathConnectionFactory import ClassPathConnectionFactory, \
+	ConnectionPair
+
+
+class ClassPathConnectionFactoryTest(unittest.TestCase):
+	factory=ClassPathConnectionFactory()
+	PARTYREF = PartyRef(URI("pythonpath:test.testparty.TestParty.TestParty"))
+
+
+	def testWrongURI(self): 
+		self.assertRaises(ValueError, 
+				lambda:self.factory.connect(PartyRef(URI("http://blabla"))))
+
+
+	def testNullPath(self):
+		# bad because classpath should not start with //
+		self.assertRaises(ValueError, lambda:self.factory.connect(PartyRef(URI(
+			"pythonpath://some.class.path"))))
+
+	def testUnknownParty(self):
+		self.assertRaises(ValueError, lambda:self.factory.connect(PartyRef(URI(
+			"pythonpath:blabla.bla"))))
+
+	def testParty(self) :
+		conn = self.factory.connect(self.PARTYREF)
+		self.assertIsNotNone(conn)
+		conn.close()
+
+	def testConnectionPairProtocolClosesNormally(self):
+		cpair = ConnectionPair(self.PARTYREF);
+		self.assertEquals(2, len(cpair.getOpenConnections()))
+		cpair.getProtocolToPartyConn().close()
+		time.sleep(0.1)
+		self.assertEqual(0, len(cpair.getOpenConnections()))
+			
+	def testConnectionPairProtocolClosesWithExc(self):
+		cpair = ConnectionPair(self.PARTYREF)
+		self.assertEqual(2, len(cpair.getOpenConnections()))
+		cpair.getProtocolToPartyConn().setError(ValueError("test"))
+		time.sleep(0.1)
+		self.assertEqual(0, len(cpair.getOpenConnections()))
+
+	def testConnectionPairPartyClosesNormally(self):
+		cpair = ConnectionPair(self.PARTYREF)
+		self.assertEqual(2, len(cpair.getOpenConnections()))
+		cpair._getPartyToProtocolConn().close()
+		time.sleep(0.1)
+
+		self.assertEqual(0, len(cpair.getOpenConnections()))
+
+	def testConnectionPairPartyClosesWithExc(self):
+		cpair = ConnectionPair(self.PARTYREF)
+		self.assertEqual(2, len(cpair.getOpenConnections()))
+		cpair._getPartyToProtocolConn().setError(ValueError("test"))
+		time.sleep(0.1)
+		self.assertEqual(0, len(cpair.getOpenConnections()))
+			
Index: geniuswebcore/test/geniusweb/simplerunner/SessionRunnerE2ETest.py
===================================================================
--- geniuswebcore/test/geniusweb/simplerunner/SessionRunnerE2ETest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/simplerunner/SessionRunnerE2ETest.py	(revision 67)
@@ -0,0 +1,64 @@
+from fileinput import filename
+import json
+from pathlib import Path
+import unittest
+from unittest.mock import Mock
+
+from pyson.ObjectMapper import ObjectMapper
+from tudelft_utilities_logging.ReportToLogger import ReportToLogger
+
+from geniusweb.protocol.NegoSettings import NegoSettings
+from geniusweb.simplerunner.ClassPathConnectionFactory import ClassPathConnectionFactory
+from geniusweb.simplerunner.NegoRunner import NegoRunner
+
+
+class SessionRunnerE2ETest(unittest.TestCase):
+	'''
+	E2E test doing a full real run of a session with real agents and protocol.
+	NOTICE This will exercise a full system to errors here may point far outside
+	this module.
+	'''
+	TEST_RUNTIME = 5000
+	jackson = ObjectMapper()
+	logger = Mock(ReportToLogger("test"))
+	filename:str
+	runner:NegoRunner
+
+	params = ["test/resources/settings.json", 
+# 				 "test/resources/settings2.json" ,          PARTIALORDERING NOT YET
+ 				 "test/resources/settingsbadprofile.json"
+# 				 "test/resources/shaoptoursettings.json",   ALLPERMUTATIONSETTINGS NOT YET
+# 				 "test/resources/mopac.json" ,              MOPAC NOT YET
+# 				 "test/resources/tournament.json"			ALLPERMUTATIONSETTINGS NOT YET
+				 ]
+
+
+	
+	def testAll(self):
+		''' 
+		runs all the tests. Python has no standard 'parameterized' mechanism
+		so we have to do it ourselves.
+		'''
+		for filename in self.params:
+			self.filename=filename
+			with self.subTest("before "+self.filename):
+				self.before()
+			with self.subTest("runMain"+self.filename):
+				self.runTestMainFunction()
+
+	def before(self):
+		print("Running from file " + self.filename)
+		serialized = Path(self.filename).read_text("utf-8")
+		settings=self.jackson.parse(json.loads(serialized), NegoSettings)
+		self.runner = NegoRunner(settings, ClassPathConnectionFactory(),
+				self.logger,self.TEST_RUNTIME)
+			
+	def runTestMainFunction(self) :
+		NegoRunner.main([self.filename])
+
+	def runTest(self) :
+		self.runner.run()
+		print("Final state:\n" + str(self.runner.getProtocol().getState()))
+		self.assertTrue(self.runner.isProperlyStopped())
+		# check no warnings and more severe
+		self.asssertEqual([], self.logger.log.call_args_list)
Index: geniuswebcore/test/geniusweb/simplerunner/SessionRunnerTest.py1
===================================================================
--- geniuswebcore/test/geniusweb/simplerunner/SessionRunnerTest.py1	(revision 67)
+++ geniuswebcore/test/geniusweb/simplerunner/SessionRunnerTest.py1	(revision 67)
@@ -0,0 +1,58 @@
+import unittest
+from unittest.mock import Mock
+
+from tudelft_utilities_logging.ReportToLogger import ReportToLogger
+from tudelft_utilities_logging.Reporter import Reporter
+
+from geniusweb.actions.PartyId import PartyId
+from geniusweb.protocol.CurrentNegoState import CurrentNegoState
+from geniusweb.protocol.ProtocolException import ProtocolException
+from geniusweb.protocol.session.SessionProtocol import SessionProtocol
+from geniusweb.protocol.session.SessionSettings import SessionSettings
+from geniusweb.protocol.session.SessionState import SessionState
+from geniusweb.simplerunner.ClassPathConnectionFactory import ClassPathConnectionFactory
+from geniusweb.simplerunner.NegoRunner import NegoRunner
+import unittest.mock as mock
+
+
+class SessionRunnerTest(unittest.TestCase):
+	PROTOCOL_EXC = ProtocolException(
+			"fake protocol exception", PartyId("test"))
+	NOW = 1000
+	logger = ReportToLogger("test")
+
+	def setUp(self):
+		self.finishedEvent = Mock(CurrentNegoState)
+		self.finishedstate = Mock(SessionState)
+		self.finishedstate.isFinal=Mock(return_value=True)
+		self.finishedEvent.getState=Mock(return_value=self.finishedstate)
+
+	def testSmoke(self):
+		NegoRunner(Mock(SessionSettings),
+				Mock(ClassPathConnectionFactory), self.logger, 5000)
+
+	def testRun(self):
+		settings = Mock(SessionSettings)
+		protocol = Mock(SessionProtocol)
+		settings.getProtocol=Mock(return_value=protocol)
+		factory = Mock(	ClassPathConnectionFactory)
+
+		runner=NegoRunner(settings, factory, self.logger, 5000)
+		
+		spyProtocolAddlistener = mock.patch.object(protocol, 'addListener',wraps=protocol.addListener)
+		spyProtocolStart = mock.patch.object(protocol, 'start',wraps=protocol.start)
+		spyRunnerStop:Mock = mock.patch.object(runner, 'stop', wraps=runner._stop)
+		
+		runner.run();
+		spyProtocolAddlistener.test_assert_called_once()
+		spyProtocolStart.test_assert_called_once()
+		spyRunnerStop.test_assert_not_called()
+
+
+	def testStopNormally(self):
+		# CAN NOT TEST: PYTHON HAS NO SPY WITH ARG CAPTURE
+		pass
+	
+	def testStopWithError(self) :
+		# CAN NOT TEST: PYTHON HAS NO SPY WITH ARG CAPTURE
+		pass
Index: geniuswebcore/test/geniusweb/utilsTest.py
===================================================================
--- geniuswebcore/test/geniusweb/utilsTest.py	(revision 67)
+++ geniuswebcore/test/geniusweb/utilsTest.py	(revision 67)
@@ -0,0 +1,11 @@
+import unittest
+from geniusweb.utils import val
+
+
+class utilsTest (unittest.TestCase):
+    def testVal(self):
+        a:Optional[int]=None
+        self.assertRaises(ValueError, lambda:val(a))
+        a=1
+        self.assertEqual(1, val(a))
+        
